# -*- coding: utf-8 -*-
from setuphelpers import *
import json

# Defining variables
bin_name_sub = "camotics_%s_AMD64.exe"
silent_args = "/S"
app_uninstallkey = "CAMotics"


def update_package():
    print("Download/Update package content from upstream binary sources")

    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    repo_git = "CauldronDevelopmentLLC/CAMotics"
    url_api = "https://api.github.com/repos/%s/releases/latest" % repo_git

    # Getting latest informations from GitHub API
    json_load = json.loads(wgets(url_api, proxies=proxies))
    version = json_load["tag_name"]
    # If difference between git version and bin version
    version_git = version
    version = version.replace("-release", "")
    latest_bin = bin_name_sub % version

    url_dl = "https://github.com/%s/releases/download/%s/%s" % (repo_git, version_git, latest_bin)

    print("Latest " + app_name + " version is: " + version)
    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Changing version of the package
        control.version = "%s-%s" % (version, control.version.split("-", 1)[-1])
        control.save_control_to_wapt()
        print("Changing package version to: %s in WAPT\\control" % control.version)
    else:
        print("This package is already up-to-date")

    # Deleting outdated binaries
    remove_outdated_binaries(version)
